---
Title: Gitlab and Github
Author: Tamas
Title:
  - use for software, plots and analysis
  - integration to github
  - Documentation on Git & automatic software docs
status: draft
---

### Gitlab & Docker server

#### Gitlab

KM3NeT uses a self-hosted GitLab instance as the main platform to develop and
discuss software, analysis tools, papers and other private or collaborative
creations. GitLab offers professional and advanced features to keep track of
development history and its rich feature set allows to exchange and archive
thoughts and ideas easily. The continuous integration (CI) that is part of the
GitLab distribution, proves to be a powerful automation tool and is utilised to
generate consistently up-to-date test reports, documentation and software
releases in a transparent way. The CI pipeline is triggered every time when
changes are pushed to a project. Each job runs in an isolated Docker container
which makes them fully reproducible.

![CI Pipelines of the km3pipe projects showing a failing test in a Python 3.6 environment](/figures/ci-pipelines.png)

In case of test reports for example, failing tests are signalised in merge
requests and prevent changes that broke them to be applied accidentally. The
documentation is also built in a dedicated pipeline job and is published to the
web upon successful generation. A tight integration of the documentation into
the software projects is mandatory and highly improves its up-to-dateness.

The KM3NeT GitLab server is accessible to the public but only projects which are
marked as _global_ are visible to a regular visitor without a KM3NeT account.
They can download the projects and all the public branches, access the issues,
documentation and Wiki, they however are not allowed to collaborate, i.e. to
comment or contribute in any way. To circumvent this problem, open source
projects are mirrored to a yet inofficial GitHub group
(https://github.com/KM3NeT) where everyone with a GitHub account is allowed to
interact.
